/************************************************************************/
/*

                CE FICHIER EST UN "include" de ADDQUART.C

 IL CONTIENT L'ALGO DE GLOUTON.C adapt pour traiter separement les differentes
 multifourches de l'arbre construit par ||* , et aussi la definition de la
 plupart des structs de donnees necessaires aux 2 progs.

A FAIRE : 

- stockage plus compact des quads 
- repartir les quads entre les differentes multi pour ne pas avoir besoin de MatQ[][][][].
  Est-ce faisable en ayant tjs du O(n^4) ???

----------------------------------------------------
version 1.4 :

- peut traiter des poids apposes aux quadruplets ds les fichiers quartfile
- accepte des noms de taxa de 30 caracteres.

----------------------------------------------------
 */


/************************************************************************/
#define Max_nb_taxa 31
#define Max_nb_noeuds 2*Max_nb_taxa
#define Gde_Cte 9999

char name[Max_nb_taxa+1][30]; /* nom des taxa */

FILE *farbre,*fcritere;

/* Pour stocker les quadruplets (on utilise un bidon) - list dbmt chainee */
typedef struct listequads {
                           int gche[2],dte[2];
			   double score;
			   char typ;
			   struct listequads *suiv,*prec;
			   struct listequads *qdsuiv;
			 } listequads;
listequads *Lq;
int nbquadsLq=0;
/* Pr stocker les 3 parties du critere d'agglomeration : 
   sat,contre,resolu alors que irres ds data */
typedef struct critere { int x,y,w;} critere;
critere Critere_global;

/*--------- pr resolution des multifourches  -----*/
int Multifourches[Max_nb_noeuds];
int nb_multi=0;
int contient_tax[Max_nb_taxa];

/* BIPARTITIONS : numbip | gche ou dte | liste des objets */ 
int bipartition[Max_nb_noeuds+1][3][Max_nb_taxa]; /* 1 = 1er indice utilise */

/* -------------- structure de l'arbre non-enracine ------------- */
typedef struct TaxList { struct TaxList *suiv; int num;} TaxList;
/* venant de tree-popping.c */
typedef struct tarbre {
                       int taxa[Max_nb_taxa];  /* liste non-ordonnee */
		       int num; /* du noeud */
                       struct tarbre *voisins[Max_nb_noeuds]; /*non-ordonnee */
		       TaxList *tax_sousarb[Max_nb_noeuds]; /* pr chq voisin 
                           ci-dessus, stocke la liste des espces que 
                           sa sous-arbo contient */
                      } tarbre;

/*------- Var Globales ----------*/
tarbre *noeuds[Max_nb_noeuds+1]; /* adressage direct de chq noeud ds
				    l'arbre en fonction de son num*/
tarbre *sommet[Max_nb_taxa+1]; /* ptr du taxon vers le sommet de
				    l'arbre qui le contient */
/* pour stocker les r4-arbres de Q (on a toujours i1<i2, i3<i4, i1<i3) */
double MatQ[Max_nb_taxa+1][Max_nb_taxa+1][Max_nb_taxa+1][Max_nb_taxa+1];

int Nb_Bips=0;
tarbre *Arbre;   /* pointeur sur le noeud de depart */
int Num_prochain_noeud; /* pr numeroter les noeuds internes */
int Nb_noeuds_agreg; /* nb d'elem encore a agreger */
int Nb_taxa;
int fully_resolved=0;
/*-------------------------------------------------*/
/* typedef struct listequads : ds "resoudmulti.c" */ 
listequads *lquads;
/*--------------*/
FILE *fbip;

/*float Gains[Max_nb_taxa]; *//* stocke les |sat|/|contre| de chq etape */
int represent[Max_nb_taxa+1]; /* nom du noeud interne au sous-arb duquel est
		                   attachee esp i */
int ref[Max_nb_noeuds+1]; /* num de la lig et col de la matrice pr le noeud i */
int refinv[Max_nb_taxa];  /* inverse : num lig/col -> num noeuds */
float a = 1.0;    /* parametre du critere (x-ay) d'evaluation des
	           agregations candidates */

typedef struct Tagreg { 
                        int x,y,w; /* nb de quadruplets */
			double sx,sy,sw; /* somme des supports des quads */
                        listequads *Lqd;} Tagreg;

Tagreg Agi[Max_nb_taxa][Max_nb_taxa];/* convention [lig][col]
                          et 1/2 matrice inf utilisee : lig > col.*/

/*---------------------------------------------------------------*/
/*---------------         FUNCTIONS          --------------------*/
/*---------------------------------------------------------------*/
void Erreur(mess,valerr)
char *mess;int valerr;
{
printf("\n\n\tERROR: %s\n\n",mess);
printf("Please send a bug report to vberry@lirmm.fr for explanations/corrections\n");
exit(valerr);
} 
/*--------------------------------------------------*/
int Choix(esp1,esp2)
int *esp1, *esp2;
{/* Glob : x- (y+w)
    Local : lex(y+w,x)
    Si des exequos, choisit au hasard */ 

    /* !! permet les ag_i / x=0,y=0, du moment qu'il reste des
       quadruplets a resoudre ds Q */

int i,j,ch,nieme=0;
int exequos=0,nbexequos=1; /* pour les choix exequo */
double bestX=0.0,bestY=0.0,bestW=0.0,bestsX=0.0,bestsY=0.0,bestsW=0.0;
double score,bestYW=30000.0,bestsYW=30000.0;
for (i=0;i<Nb_noeuds_agreg;i++)
  for (j=0;j<i;j++)
    {
      score = Agi[i][j].sy+Agi[i][j].sw;
 /* printf("agregation de %d et %d coute score = %f\n",refinv[i],refinv[j],score);*/
     /* Si exequos garde celui qui satisfait le plus de quadruplets */
     if (score == bestsYW)
       {
        if (Agi[i][j].sx==bestX) {exequos=1;nbexequos++;}
        if (Agi[i][j].sx>bestX)  
	  {*esp1=refinv[i];*esp2=refinv[j];bestX=Agi[i][j].sx;
           exequos=0;nbexequos=1;}
        }
     if (score < bestsYW)
      {bestsYW=score;bestsX=Agi[i][j].sx;
       bestYW=Agi[i][j].y+Agi[i][j].w;bestX=Agi[i][j].x;
       *esp1=refinv[i];*esp2=refinv[j];exequos=0;nbexequos=1;}
    }
/* si on n'a des exequos, choisir au hasard entre eux */
if (exequos)
  {ch=1+((int)rint(random() % nbexequos));
   /*printf("je choisis le numero %d parmi les %d exequos\n",ch,nbexequos);*/
   for (i=0;i<Nb_noeuds_agreg;i++)
     for (j=0;j<i;j++)
       {score = Agi[i][j].sy+Agi[i][j].sw;
        if ((score == bestsYW) && (Agi[i][j].sx==bestsX)) 
         {nieme++;if (nieme==ch) {*esp1=refinv[i];*esp2=refinv[j];}}
       }
  }
/* renvoie le gain pr le critere global X - Y+W */
/*printf("X=%d Y+W=%d\n",bestX,meilleuryw);*/
return(bestX-bestYW);
}

/*-----------------------------------*/
int Quelle_Agi(q,lc1,lc2)
listequads *q;int *lc1,*lc2;
{int tmp;
/* Pour le r4-arbre q = ij||kl, renvoie les coord lig/col ds la matrice Agi 
de la case correspondant a l'agregation des branches contenant i et j */
*lc1=ref[represent[q->gche[0]]];
*lc2=ref[represent[q->gche[1]]];
if (*lc1<*lc2) {tmp=*lc1;*lc1=*lc2;*lc2=tmp;}
}
/*--------------------------------------------------*/
void MAJ_Lq_Matrice(nd1,nd2,cptr)
int nd1,nd2,cptr; /* cptr = neo noeud remplacant nd1 et nd2 */
{
/* Parcourt les quadruplets en enlevant ceux satisfaits ou contredits
   par les especes qu'on vient d'assembler. En effet, une fois sat ou
   contredit par une agreg, aucune agglom future ne pourra changer
   leur statut.
   Quant aux autres quads, les utilise pour remplir la matrice diminuee */
listequads *elem,*prec,*q,*qm,*qtmp;
int i,j,plusgd,pluspetit,t1,t2,t3,t4;
int esp1,esp2,lc1,lc2;

/*printf("ref avant modif :\n noeud :");
for (i=1;i<=cptr;i++) printf("%d\t",i);printf("\n        ");
for (i=1;i<=cptr;i++) printf("%d\t",ref[i]);printf("\n");*/

if (ref[nd1]<ref[nd2]) {pluspetit=ref[nd1];plusgd=ref[nd2];}
else                   {pluspetit=ref[nd2];plusgd=ref[nd1];}
ref[cptr]=pluspetit; 
/* --------------------------------- -------*/
/* ------- MAJ DE LA MATRICE DES AGi -------*/
/* --------------------------------- -------*/
/* Supprime chq r4-arbre resolu et les autres r4-arbres lies au meme quad */
/* Pour chacun de ces r4-arb, maj le support de l'Agi concernee */
/*printf("j'enleve les r4-tree du quad ");*/
q=Agi[plusgd][pluspetit].Lqd;
if (q)
  do
    { /*printf("(%d,%d,%d,%d) ",q->gche[0],q->gche[1],q->dte[0],q->dte[1]);*/
      for (qm=q->qdsuiv;qm!=q;qm=qm->qdsuiv)
	{Quelle_Agi(qm,&lc1,&lc2);
	switch (qm->typ) {
	 case 'x':{(Agi[lc1][lc2].sx)-=qm->score;(Agi[lc1][lc2].x)--;}break;
	 case 'y':{(Agi[lc1][lc2].sy)-=qm->score;(Agi[lc1][lc2].y)--;}break;
	 case 'w':{(Agi[lc1][lc2].sw)-=qm->score;(Agi[lc1][lc2].w)--;}break;
	 default:{printf("ERR : r4-tree de type <> (x,y,w)!!!\n");exit(-1);}
	 }
	 /* l'enleve physiquement de la liste */
	  if (qm->suiv==qm) Agi[lc1][lc2].Lqd=NULL; /* free ne marche pas */
	  else
	    {if (Agi[lc1][lc2].Lqd==qm) Agi[lc1][lc2].Lqd=qm->suiv;
	     qm->prec->suiv=qm->suiv;qm->suiv->prec=qm->prec;}
        }
      q=q->suiv;}
  while (q!=Agi[plusgd][pluspetit].Lqd); /* tq pas revenu au depart */
else printf("\n\n\tBIZARRE l'Agi resolu ne concerne aucun r4-arbre!!!!\n\n");
Agi[plusgd][pluspetit].Lqd=NULL;
/* COMPRIME LA MATRICE DES AGi */
/* 1: le neo nd, z, remplace celui des agreges qui a le plus petit indice */
/* on reaffecte les col et lig aux noeuds */

/* Calcule le support des nouvelles agreg potentielles */
for (i=0;i<Nb_noeuds_agreg;i++)
  { 
  if ((i!=pluspetit) && (i!=plusgd))
    {if (i<pluspetit)  /*i < pluspetit < plusgd */
     {Agi[pluspetit][i].x+=Agi[plusgd][i].x;
      Agi[pluspetit][i].sx+=Agi[plusgd][i].sx;
      Agi[pluspetit][i].y+=Agi[plusgd][i].y;
      Agi[pluspetit][i].sy+=Agi[plusgd][i].sy;
      Agi[pluspetit][i].w+=Agi[plusgd][i].w;
      Agi[pluspetit][i].sw+=Agi[plusgd][i].sw;
      /* Union en O(1) des listes de r4-arbres dbmt chainees */
      if (Agi[plusgd][i].Lqd)
	{if (!Agi[pluspetit][i].Lqd) 
	   Agi[pluspetit][i].Lqd=Agi[plusgd][i].Lqd;
	else {
	  Agi[pluspetit][i].Lqd->prec->suiv=Agi[plusgd][i].Lqd;
	  Agi[plusgd][i].Lqd->prec->suiv=Agi[pluspetit][i].Lqd;
	  qtmp=Agi[pluspetit][i].Lqd->prec;
	  Agi[pluspetit][i].Lqd->prec=Agi[plusgd][i].Lqd->prec;
	  Agi[plusgd][i].Lqd->prec=qtmp;}}	 
     }
     if (i>pluspetit)
      {if (i<plusgd) /* pluspetit < i < plusgd */
	 {Agi[i][pluspetit].x+=Agi[plusgd][i].x;
	  Agi[i][pluspetit].sx+=Agi[plusgd][i].sx;
	  Agi[i][pluspetit].y+=Agi[plusgd][i].y;
	  Agi[i][pluspetit].sy+=Agi[plusgd][i].sy;
	  Agi[i][pluspetit].w+=Agi[plusgd][i].w;
	  Agi[i][pluspetit].sw+=Agi[plusgd][i].sw;
	  /* Union en O(1) des listes de r4-arbres dbmt chainees */
	  if (Agi[plusgd][i].Lqd)
	    {if (!Agi[i][pluspetit].Lqd) 
	      Agi[i][pluspetit].Lqd=Agi[plusgd][i].Lqd;
	    else {
	      Agi[i][pluspetit].Lqd->prec->suiv=Agi[plusgd][i].Lqd;
	      Agi[plusgd][i].Lqd->prec->suiv=Agi[i][pluspetit].Lqd;
	      qtmp=Agi[i][pluspetit].Lqd->prec;
	      Agi[i][pluspetit].Lqd->prec=Agi[plusgd][i].Lqd->prec;
	      Agi[plusgd][i].Lqd->prec=qtmp;}}
	}
       else /* pluspetit < plusgd < i */
	 {Agi[i][pluspetit].x+=Agi[i][plusgd].x;
	  Agi[i][pluspetit].sx+=Agi[i][plusgd].sx;
	  Agi[i][pluspetit].y+=Agi[i][plusgd].y;
	  Agi[i][pluspetit].sy+=Agi[i][plusgd].sy;
	  Agi[i][pluspetit].w+=Agi[i][plusgd].w;
	  Agi[i][pluspetit].sw+=Agi[i][plusgd].sw;
	  /* Union en O(1) des listes de r4-arbres dbmt chainees */
	  if (Agi[i][plusgd].Lqd)
	    {if (!Agi[i][pluspetit].Lqd) 
	      Agi[i][pluspetit].Lqd=Agi[i][plusgd].Lqd;
	    else {
	      Agi[i][pluspetit].Lqd->prec->suiv=Agi[i][plusgd].Lqd;
	      Agi[i][plusgd].Lqd->prec->suiv=Agi[i][pluspetit].Lqd;
	      qtmp=Agi[i][pluspetit].Lqd->prec;
	      Agi[i][pluspetit].Lqd->prec=Agi[i][plusgd].Lqd->prec;
	      Agi[i][plusgd].Lqd->prec=qtmp;}
	   }
	}
     }
   }
  } /* pour ch autre noeud */

/* 2: le trou laisse par le nd agrege le plus grand est comble 
   par les nds suivants de la matrice des Agi */

/* on decale a gche les cols a dte */
for (j=plusgd;j<Nb_noeuds_agreg;j++)
  for (i=j+1;i<Nb_noeuds_agreg;i++)
    {Agi[i][j].x=Agi[i][j+1].x;Agi[i][j].y=Agi[i][j+1].y;
     Agi[i][j].sx=Agi[i][j+1].sx;Agi[i][j].sy=Agi[i][j+1].sy;
     Agi[i][j].w=Agi[i][j+1].w;Agi[i][j].sw=Agi[i][j+1].sw;
     Agi[i][j].Lqd=Agi[i][j+1].Lqd;}
/* on remonte les ligs du dessous */
for (i=plusgd;i<Nb_noeuds_agreg-1;i++)
  for (j=0;j<i;j++)
    {Agi[i][j].x=Agi[i+1][j].x;Agi[i][j].y=Agi[i+1][j].y;
     Agi[i][j].sx=Agi[i+1][j].sx;Agi[i][j].sy=Agi[i+1][j].sy;
     Agi[i][j].w=Agi[i+1][j].w;Agi[i][j].sw=Agi[i+1][j].sw;
     Agi[i][j].Lqd=Agi[i+1][j].Lqd;}

ref[nd1]=-1;ref[nd2]=-1;

/* met a jour les structures de reperages des nds */
for (i=1;i<=cptr;i++) if (ref[i]>plusgd) ref[i]=ref[i]-1;
for (i=1;i<=cptr;i++) if (ref[i]!=-1) refinv[ref[i]]=i; 

/* fait pointer les especes des noeuds agreges nd1 et nd2 sur le neo
   noeud interne */ 
for (i=1;i<=Nb_taxa;i++)
 if ((represent[i]==nd1) || (represent[i]==nd2)) represent[i]=cptr;
}
/*--------------------------------------------------*/
void Separe_noeud_arbre(num,nd1,nd2,xneo,yneo,wneo)
int num,nd1,nd2,xneo,yneo,wneo;
/* Agrege dans la multifourche "num" les noeuds "nd1" et "nd2", en
   creant ds l'arbre un neo noeud relie a leur place a la multifourche */
/* Sauve aussi la neo bipartition creee par cette agglomeration */
{
int tax[Max_nb_taxa];
int cpt1,cpt2;
tarbre *neosom,*ptr1,*ptr2,*ptrmulti;
int i,first=1,second;
int nomb;

ptrmulti=noeuds[Multifourches[num]]; 
if ((neosom=(tarbre *)malloc(sizeof(tarbre)))==0) 
    {printf("MEMORY ALLOCATION ERROR (no more space available)\n");
     exit(-3);}
neosom->num=Num_prochain_noeud;noeuds[neosom->num]=neosom;
for (i=0;i<Max_nb_taxa;i++) neosom->taxa[i]=0; /* ne contient aucun taxon */
/* Le neo noeud a 3 voisins : nd1, nd2 et la multifourche */
neosom->voisins[0]=noeuds[nd1];neosom->voisins[1]=noeuds[nd2];
neosom->voisins[2]=ptrmulti;
for (i=3;i<Max_nb_noeuds;i++) neosom->voisins[i]=NULL;

/* Fait pointer nd1 et nd2 vers lui plutot que vers multifourche */ 
ptr1=noeuds[nd1];ptr2=noeuds[nd2];
for (i=0;(ptr1->voisins[i]!=ptrmulti) && (ptr1->voisins[i]);i++)
if (!ptr1->voisins[i]) Erreur("(internal) : NOT FINDING THE MULTI NODE\n",5);
ptr1->voisins[i]=neosom;
for (i=0;(ptr2->voisins[i]!=ptrmulti) && (ptr2->voisins[i]);i++)
if (!ptr2->voisins[i]) Erreur("(internal) : NOT FINDING THE MULTI NODE\n",5);
ptr2->voisins[i]=neosom;

/* Remplace nd1 et nd2 par neosom ds les voisins du noeud multifourche */
for (i=0;ptrmulti->voisins[i];i++)
  {
   if ((ptrmulti->voisins[i]==ptr1) || (ptrmulti->voisins[i]==ptr2))
     {if (first)
       {first=0;ptrmulti->voisins[i]=neosom;}
      else second=i;
     }
 }
ptrmulti->voisins[second]=ptrmulti->voisins[i-1]; /* remplace par le dernier*/
ptrmulti->voisins[i-1]=NULL;

  /*****************************************************************/
  /* Calcule la bipartition engendree et l'ajoute a "bipartitions" */
  /*****************************************************************/ 
Nb_Bips++;
cpt1=1;cpt2=0;
for(i=1;i<=Nb_taxa;i++) contient_tax[i]=0;
for (i=1;i<=Nb_taxa;i++)
 if ((represent[i]==nd1) || (represent[i]==nd2))
   {contient_tax[cpt1]=i;bipartition[Nb_Bips][1][cpt1-1]=i;(cpt1)++;}
 else
   {bipartition[Nb_Bips][2][cpt2]=i;(cpt2)++;}
bipartition[Nb_Bips][1][cpt1-1]=0;bipartition[Nb_Bips][2][cpt2]=0;

/*printf("par les REPRESENTANTS je trouve les esps :");
for (i=1;i<=Nb_taxa;i++) printf("%.2d ",contient_tax[i]);
printf("\n");
*/

for (i=1;i<=Nb_taxa;i++) tax[i]=0;
for(i=1;contient_tax[i];i++) tax[contient_tax[i]]=1;


for (i=1;i<=Nb_taxa;i++)
    if (tax[i]) fprintf(fbip,"%.2d ",i);
fprintf(fbip,"|");
for (i=1;i<=Nb_taxa;i++)
    if (!tax[i]) fprintf(fbip," %.2d",i);
/* nb de quadruplets resolus par la bipartition.
  Attention, il ne s'agit que d'un decompte partiel, pour que
 le score ait une importance, il faut aussi tenir compte des 
 quadruplets precedemment resolus */
/*nomb = ((cpt1-1)*(cpt1-2)/2) * (cpt2*(cpt2-1)/2) ; 
printf("cette bipartition resoud %d quadruplets (%d,%d)\n",nomb,cpt1,cpt2);
printf("xneo=%d,yneo=%d,wneo=%d\n",xneo,yneo,wneo);
fprintf(fbip," (+%.2f%% sat , +%.2f%% contr, +%.2f%% non res)",100.0*xneo/nomb,100.0*yneo/nomb,100.0*wneo/nomb);*/
fprintf(fbip,"\n");
}
/*--------------------------------------------------*/
int continuer(modifcrit)
int modifcrit;
{
if (fully_resolved) return(1);
else return(modifcrit>=0);
}
/*--------------------------------------------------*/
void glouton(multi)
int multi;
{
int nd1,nd2,etape,i,tmp;
int modifcrit;
int xneo,yneo,wneo;
     /*---- Boucle principale du glouton ----*/
     /*----         agrege 2 noeuds       ---*/
etape=0;
/*Aff_Agi();*/
modifcrit=Choix(&nd1,&nd2);
if (ref[nd1]<ref[nd2]) {tmp=nd1;nd1=nd2;nd2=tmp;}

/* continue tant qu'on gagne au global (X-Y) (cf Soda) et que Q non vide */ 
 while ( (continuer(modifcrit)) && (Nb_noeuds_agreg>3) ) 
  {
  printf(".");fflush(stdout);
  /*printf("(noeuds %d et %d) modifcrit=%d ",nd1,nd2,modifcrit);
  printf("noeuds %d et %d -> %d\n",nd1,nd2,Num_prochain_noeud);*/
  xneo=Agi[ref[nd1]][ref[nd2]].x;
  yneo=Agi[ref[nd1]][ref[nd2]].y;
  wneo=Agi[ref[nd1]][ref[nd2]].w;
  /*printf("on sat %d quad de plus, on en contredit %d de plus 
            et on en resoud %d irresolu ds Q\n",xneo,yneo,zneo);*/

  /* Fait la modif correspondante ds l'arbre */
  Separe_noeud_arbre(multi,nd1,nd2,xneo,yneo,wneo);

/*  if (Agi[ref[nd1]][ref[nd2]].y==0)
       Gains[etape]=100000.0;
  else Gains[etape]=((float)Agi[ref[nd1]][ref[nd2]].x)
                 /(float)(Agi[ref[nd1]][ref[nd2]].y+Agi[ref[nd1]][ref[nd2]].w);
*/
  /* Sauve valeur au sens du CRITERE GLOBAL X-Y   */
  Critere_global.x+=xneo;
  Critere_global.y+=yneo;
  Critere_global.w+=wneo;

  /* remplace les 2 noeuds agreges par un neo noeud */
  MAJ_Lq_Matrice(nd1,nd2,Num_prochain_noeud);
  Nb_noeuds_agreg--;

/*Aff_Agi();*/
  /*printf("refinv pr matrice ci-dessus\n");
for (i=0;i<Nb_noeuds_agreg;i++) printf("%d\t",i);printf("\n");
for (i=0;i<Nb_noeuds_agreg;i++) printf("n%d\t",refinv[i]);printf("\n");*/

  Num_prochain_noeud++;
  etape++;
  modifcrit=Choix(&nd1,&nd2);/*printf("MODIFCRIT = %d\n",modifcrit);*/
  if (ref[nd1]<ref[nd2]) {tmp=nd1;nd1=nd2;nd2=tmp;}
}
/* 
printf("Les rapports (A) |satisfaits|/|contredits| sont les suivants ds l'ordre
des agglomerations\n (10000 signifie infini, i.e. pas de contredits):\n");
for (i=0;i<etape;i++) printf("%f\n",Gains[i]);
*/
}
/*-------------------------------------*/
void Correspondance_nds_ligcol(num)
int num;
{
int i,j,numnd;
TaxList *t;
Nb_noeuds_agreg=0;
for (i=0;noeuds[Multifourches[num]]->voisins[i];i++)  Nb_noeuds_agreg++;
/*printf("il y a %d nds a agreger autour de cette multi\n",Nb_noeuds_agreg);*/
/* RAZ la matrice et les refs */
ref[0] = -1;
for (i=0;i<Max_nb_noeuds;i++) ref[i+1]=-1;
for (i=0;i<Max_nb_taxa;i++)
  {
   represent[i+1]=0;  refinv[i]=-1;  /*Gains[i]=0.0;*/
   for (j=0;j<Nb_taxa;j++)
      {Agi[i][j].x=0;Agi[i][j].y=0;Agi[i][j].w=0;
       Agi[i][j].sx=0;Agi[i][j].sy=0;Agi[i][j].sw=0;
       Agi[i][j].Lqd=NULL;}
  }
/* Positionne les structs de donnees pr traiter la multifourche courante */
for (i=0;i<Nb_noeuds_agreg;i++)
  {numnd=noeuds[Multifourches[num]]->voisins[i]->num;
   refinv[i]=numnd;
   ref[numnd]=i;
   for (t=noeuds[Multifourches[num]]->tax_sousarb[i];t;t=t->suiv)
     represent[t->num]=numnd;
  }
/*printf("\nRepresent taxa(noeud)=\n");
for (i=1;i<=Nb_taxa;i++) printf("%.2d(%d) ",i,represent[i]);printf("\n");
printf("Ref[noeud] = lig/col\n");
for (i=1;i<Num_prochain_noeud;i++) printf("%d(%d) ",i,ref[i]);printf("\n");
printf("Refinv[lig/col] = noeud\n");
for (i=0;i<Nb_taxa;i++) printf("%d(n%d) ",i,refinv[i]);printf("\n");*/
}
/*------------------------------------*/
void Resoud_multi(num)
int num;
/* initialise les structs de donnees avant de lancer glouton */
{
/*Aff_Agi();*/
/* resoud multifourche */
glouton(num);
}









